#!/usr/bin/python
import sys
import Gpib
import time
import numpy as np

nplc = 50
rngx = 10
soakt = 15
cycles = 5

log_name     = ("dcl_%dvdc_5720_3458rohs_abc_cycle5_nplc%d_soak%d_feb2021.csv" % (rngx, nplc, soakt))
log_name_raw = ("dcl_%dvdc_5720_3458rohs_abc_cycle5_nplc%d_soak%d_raw_feb2021.csv" % (rngx, nplc, soakt))

fluke = Gpib.Gpib(0, 4, timeout=30) # Fluke 5720A, GPIB Address = 5
#fluke.clear()
fluke.write("*IDN?")
print "Source detected = %s" % fluke.read()

dmm = Gpib.Gpib(0,  14, timeout=30)# Keysight 3458A, GPIB Address = 22
dmm2 = Gpib.Gpib(0, 15, timeout=30)# Keysight 3458A, GPIB Address = 22
dmm3 = Gpib.Gpib(0, 23, timeout=30)# Keysight 3458A, GPIB Address = 22
dmm.clear()
dmm.write("ID?")
print "DUT1 detected = %s" % dmm.read()

fluke.write("STBY")
fluke.write("RANGELCK OFF")
fluke.write("OUT %.2f V, 0 Hz" % rngx)
fluke.write("RANGELCK ON")
fluke.write("STBY")
fluke.write("OUT 0.0 V, 0 Hz")
fluke.write("EXTGUARD OFF")
fluke.write("OPER")
time.sleep(soakt)
print "SRC configured"
dmm.write("BEEP")
dmm.write("END ALWAYS")
dmm.write("DCV %.2f" % rngx)
dmm.write("NPLC %.2f" % nplc)
dmm.write("NDIG 8")
dmm.write("TRIG AUTO")
dmm.write("MATH OFF")
print "DUT configured 14"
dmm2.write("BEEP")
dmm2.write("END ALWAYS")
dmm2.write("DCV %.2f" % rngx)
dmm2.write("NPLC %.2f" % nplc)
dmm2.write("NDIG 8")
dmm2.write("TRIG AUTO")
dmm2.write("MATH OFF")
print "DUT configured 15"
dmm3.write("BEEP")
dmm3.write("END ALWAYS")
dmm3.write("DCV %.2f" % rngx)
dmm3.write("NPLC %.2f" % nplc)
dmm3.write("NDIG 8")
dmm3.write("TRIG AUTO")
dmm3.write("MATH OFF")
print "DUT configured 23"

#dmm.write("ACAL DCV")
#dmm2.write("ACAL DCV")
#dmm3.write("ACAL DCV")
#time.sleep(160)
'''
for vcnt in range (0,2):
    dmm3.write("*TRG;GET;RDG?")
    dmm3.read()
    dmm4.write("READ?") # Get reading
    dmm4.read()
'''
dmm.write("TARM SGL")
dmm.read()
dmm.write("MATH NULL")
dmm.write("TARM SGL") # Get reading
dmm.read()
dmm2.write("TARM SGL")
dmm2.read()
dmm2.write("MATH NULL")
dmm2.write("TARM SGL") # Get reading
dmm2.read()
dmm3.write("TARM SGL")
dmm3.read()
dmm3.write("MATH NULL")
dmm3.write("TARM SGL") # Get reading
dmm3.read()
print "DUTs is nulled to MFC zero"

with open(log_name, 'a') as dile:
    dile.write ("date;source;duta;dutb;dutc;dutd;sdev;sdev2;sdev3;sdev4;temp;temp2\r\n")
dile.close()

vcnt = 0 # temporary counter
print "Log into %s started" % log_name
dmm.write("TEMP?")
temp = float(dmm.read())
dmm2.write("TEMP?")
temp2 = float(dmm2.read())

for cix in range(0, cycles, 1):

    for i in range(-109,110,1):
	median = 0.0
        rrsdev = 0.0
	array = []
        median2 = 0.0
	sdev2 = 0.0
        array2 = []
	median3 = 0.0
        sdev3 = 0.0
	array3 = []
        median4 = 0.0
	sdev4 = 0.0
        array4 = []
	set_value = (float(i) / 10)
        fluke.write("OUT %.7f;OPER" % set_value)
	fluke.write("OPER")
        time.sleep(soakt)
	for ix in range (0,8): #take more samples
	    dmm.write("TARM SGL")
    	    dmm2.write("TARM SGL")
	    dmm3.write("TARM SGL")
    	    val = float(dmm.read())
	    val2 = float(dmm2.read())
	    val3 = float(dmm3.read())
	    val4 = set_value #float(dmm4.read())
	    array.extend([val])
	    array2.extend([val2])
	    array3.extend([val3])
	    array4.extend([val4])
	    if abs(set_value) >= 0.05:
		print("\033[33;1mA %.8f, ppm %.4f \033[35;1mB %.8f, ppm %.4f \033[37;1mC %.8f, ppm %.4f \033[32;1mD %.8f, ppm %.4f\033[39;0m" % (val, ((val / set_value - 1) * 1e6), val2,((val2 /set_value - 1) * 1e6), val3,((val3 / set_value - 1) * 1e6),val4,((val4 / set_value - 1) * 1e6) ))
    	    if (abs(val) >= 9.9e36) or (abs(val2) >= 9.9e36):
		print ("Smoke escaped, check connections")
		fluke.write("OUT 0 V")
		fluke.write("STBY")
		quit()
	    with open(log_name_raw, 'a') as dileraw:
		dileraw.write (time.strftime("%m%d%Y-%H:%M:%S;") + ("%.9f;%.9f;%.9f;%.9f;%.9f;%.6g;%.6g;%.6g;%.6g;%.1f;%.1f\r\n" % (set_value, val, val2, val3, val4, 0, 0, 0, 0, temp, temp2)))
    	    dileraw.close()

	sdev = np.std(array[1:])
	median = np.median(array[1:])
	sdev2 = np.std(array2[1:])
	median2 = np.median(array2[1:])
	sdev3 = np.std(array3[1:])
	median3 = np.median(array3[1:])
	sdev4 = np.std(array4[1:])
	median4 = np.median(array4[1:])
	if abs(float(i) / 10) >= 0.0005:
	    dev1 = ((median / set_value - 1) * 1e6)
	    dev2 = ((median2 /set_value - 1) * 1e6)
	    dev3 = ((median3 /set_value - 1) * 1e6)
	    dev4 = ((median4 /set_value - 1) * 1e6)
	    print("\033[32;1mSRC %.4f \033[33;1mA %.9f, sdev5 = %.3f uV, med5 = %.8f\033[35;1mB %.9f, sdev5 = %.3f uV, med5 = %.8f \033[34;1m Delta %.4f ppm \033[37;1mC %.9f, sdev5 = %.3f uV, med5 = %.8f\033[32;1m D %.9f, sdev5 = %.3f uV, med5 = %.8f\033[39;0m" % (set_value, val, sdev*1e6, median, val2,sdev2*1e6, median2, (dev1 - dev2),  val3,sdev3*1e6, median3, val4,sdev4*1e6, median4 ))
	with open(log_name, 'a') as dile:
    	    dile.write (time.strftime("%m%d%Y-%H:%M:%S;") + ("%.9f;%.9f;%.9f;%.9f;%.9f;%.6g;%.6g;%.6g;%.6g;%.1f;%.1f\r\n" % (set_value, median, median2, median3, median4, sdev, sdev2, sdev3, sdev4, temp, temp2)))
	dile.close()

	dmm.write("TEMP?")
	temp = float(dmm.read())
	dmm2.write("TEMP?")
	temp2 = float(dmm2.read())

fluke.write("OUT 0 V")
fluke.write("STBY")
fluke.write("RANGELCK OFF")
dmm.write("RESET")
dmm2.write("RESET")
dmm3.write("RESET")
